# ================================================================================== #
# === PSYCHOSTATS 3.1 - Ranks & Statistics & RealtimeCalc system for Psychostats === #
# === include autobalance based on KDR									         === #
# === Modification for Counter-Strike:Source Servers                             === #
# === Author: Ch@meleon (snake_nas@mail.ru)										 === #
# === Version: 0.1b																 === #
# === -------------------------------------------------------------------------- === #
# ================================================================================== #
import sys
import es
import playerlib
import MySQLdb
import popuplib

# ================================================================================== #
# ==========  G l o b a l   C o n f i g u r a t i o n  V a r i a b l e s  ========== #
# ================================================================================== #
# Modify the variables below to your needs...

# ===== Psycho Stats ===== #
ps_rewrite_points		= 0				# Overwrite points settings from psychostats web statistic
ps_enable_realtime		= 0 #not work yet			# Enables ingame realtime calc point system (disabled logs for web based calc system)
ps_autobalance			= 0 #not work yet				# Enables AutoBalance

# ==== MySQL Settings ==== #
ps_mysql_hostname		= 'localhost'	# Server / Hostname for the mysql server (webserver), localhost if webserver is on same machine as cstrike server.
ps_mysql_username		= 'root'		# Username, needed to login on the sql server
ps_mysql_password		= ''			# Password, also needed to login on the sql server
ps_mysql_database		= 'psychostats3_1'		# Database - Where you want the data to be stored.

# ==== Stats Settings ==== #
ps_stats_calc_mode		= 2				# 1 - By steam, 2 - By name, 3 - By ip (3 not work yet)
ps_stats_include_bots	= 0				# Include bots with statistics?
ps_stats_minplayers     = 4				# Minimum players on server to calc stats
ps_stats_multiplier		= 2				# Multiply gained points from a frag (Default:2)
ps_stats_maxpoints		= 40			# Set a max points (security reason) (Default:30)
ps_stats_headshotbonus	= 3				# Bonus points for headshots (p = (((pv/pa)*mul)*pw_mod)+hsbonus)
ps_stats_teamkill_loss	= 5				# Amount of points the attacker loses for a teamkill

ps_points_team_t_elim	= 5				# Team Points for Eliminating All Terrorists
ps_points_team_ct_elim	= 5				# Team Points for Eliminating All Counter-Terrorists
ps_points_team_bomb_bt	= 5				# Team Points for Bombing The Target
ps_points_team_bomb_d	= 5				# Team Points for Defusing the Bomb
ps_points_team_hostage_r= 5				# Team Points for All Hostages Rescued
ps_points_team_hostage_k= 2				# Team Points for Hostages Not Rescued

ps_points_bomb_planted  = 10			# Player points for Planting The Bomb
ps_points_bomb_defused  = 10			# Player points for Defusing The Bomb
ps_points_hostage_resc	= 5				# Player points for rescuing a hostage
ps_points_hostage_kill	= 3				# Player points penalty for killing a hostage

# Weapon Bonuses ( Base Points * WeaponBonus )
ps_bonus_weapon_glock			= 2
ps_bonus_weapon_usp				= 2
ps_bonus_weapon_p228			= 2
ps_bonus_weapon_deagle			= 2
ps_bonus_weapon_fiveseven		= 2
ps_bonus_weapon_elite			= 2
ps_bonus_weapon_m3				= 1
ps_bonus_weapon_xm1014			= 1
ps_bonus_weapon_tmp				= 1
ps_bonus_weapon_mac10			= 1
ps_bonus_weapon_mp5navy			= 1
ps_bonus_weapon_ump45			= 1
ps_bonus_weapon_p90				= 1
ps_bonus_weapon_famas			= 1
ps_bonus_weapon_galil			= 1
ps_bonus_weapon_ak47			= 1
ps_bonus_weapon_scout			= 2
ps_bonus_weapon_m4a1			= 1
ps_bonus_weapon_sg550			= 1
ps_bonus_weapon_g3sg1			= 1
ps_bonus_weapon_awp				= 0.5
ps_bonus_weapon_sg552			= 1
ps_bonus_weapon_aug				= 1
ps_bonus_weapon_m249			= 1
ps_bonus_weapon_hegrenade		= 4
ps_bonus_weapon_flashbang		= 1
ps_bonus_weapon_smokegrenade 	= 1
ps_bonus_weapon_knife			= 7

# ==== Language Vars ==== #
ps_txt_objective_ct_eliminated		= '#Green All Counter-Terrorists Eliminated'
ps_txt_objective_t_eliminated		= '#Green All Terrorists Eliminated'
ps_txt_objective_target_bombed		= '#Green Target Bombed'
ps_txt_objective_bomb_planted		= 'Planting the Bomb'
ps_txt_objective_bomb_defused2		= 'Defusing the Bomb'
ps_txt_objective_bomb_defused		= '#Green Defusing the Bomb'
ps_txt_objective_hostage_killed		= '#Green Killing a Hostage'
ps_txt_objective_hostage_r			= '#Green All Hostages Rescued'
ps_txt_objective_hostage_nr			= '#Green Hostages Not Rescued'
ps_txt_objective_hostage_resc		= 'Rescuing a Hostage'
ps_txt_objective_hostage_kill		= 'Killing a Hostage'
# --- Do NOT modify below this line --- #
sql_c = ''
info = es.AddonInfo()
info.name = 'Psychostats3.1 Ranks & Statistics'
info.basename = 'psstats'
topn = 0
# ================================================================================== #
# ===============  M a i n   M o d u l e   A d d o n   S o u r c e  ================ #
# ================================================================================== #
def load():
	cst.init()

def player_say(e):
	chatcmd 	= e['text']
	userid 		= e['userid']
	uid			= cst.getUniqueId(userid)
	name 		= es.getplayername(userid)


	# === RANK === #
	if(chatcmd == 'psrank'):
		uid		= cst.getUniqueId(userid)
		data	= stats.getPlayerData(uid)
		es.msg( str(name) + ' is on place ' + str(data[1]) + ' of ' + str(data[5]) + ' with ' + str(data[3]) + ' points.')


	# === SESSION / KPD / STATSME === #
	if(chatcmd == 'pssession'):
		showkpd(userid)
	if(chatcmd == 'psstatsme'):
		showstatsme(userid)
	if(chatcmd == 'pskpd'):
		showkpd(userid)

#statsme
def showstatsme(userid):
	global rankPopup
	uid				= cst.getUniqueId(userid)
	data 			= stats.getPlayerData(uid)
	rank			= data[1]
	rank_old		= data[2]
	skill 			= data[3]
	skill_old		= data[4]
	plrcnt			= data[5]
	plr_kills		= data[6]
	plr_deaths		= data[7]
	plr_hskills		= data[8]
 	plr_ffkills		= data[9]
	plr_ffdeaths	= data[10]
	plr_kills_str	= data[11]
	plr_deaths_str	= data[12]
	plr_suicides	= data[13]
	plr_games		= data[14]
	plr_rounds		= data[15]
	plr_online		= data[16]
	plr_ctkills		= data[17]
	plr_tkills		= data[18]
	plr_ctdeaths	= data[19]
	pld_tdeaths		= data[20]
	pld_bomb_def_att= data[21]
	pld_bomb_def_def= data[22]
	pld_bomb_exp	= data[23]
	pld_bomb_pl		= data[24]
	pld_bomd_sp		= data[25]
	pld_killhost	= data[26]
	pld_reschost	= data[27]
	pld_touchhost	= data[28]
	pld_ctwon		= data[29]
	pld_ctlost		= data[30]
	pld_twon		= data[31]
	pld_tlost		= data[32]
	plr_s_points	= data[33]
	plr_s_kills		= data[34]
	plr_s_deaths	= data[35]
	plr_s_hk		= data[36]
	plr_s_ffkills	= data[37]
	prl_s_ffdeaths	= data[38]
	plr_s_suicides	= data[39]

	rankchange = rank_old - rank
	if(rankchange > 0):
		rc = '+' + str(rankchange)
	elif(rankchange < 0):
		rc = str(rankchange)
	else:
		rc = ''

	skillchange = skill - skill_old
	if(skillchange > 0):
		skc = '+' + str(skillchange)
	elif(skillchange < 0):
		skc = str(skillchange)
	else:
		skc = ''

	if (plr_deaths == 0):
		kdr = "%.2f" % round(float(plr_kills)/float(1),2)
	else:
		kdr = "%.2f" % round(float(plr_kills)/float(plr_deaths),2)

	t_rounds = pld_twon + pld_tlost
	ct_rounds = pld_ctwon + pld_ctlost
	if (t_rounds > ct_rounds):
		pref_team = 'T'
	else:
		pref_team = 'CT'

	try:
		kpm = "%.2f" % round( float(plr_kills) / float(plr_online) * 60 ,2)
	except:
		kpm = "0.00"

	rankPopup = popuplib.create('rank_popup')
	rankPopup.addline('->1 - Player Rundown')
	rankPopup.addline('      Position ' + str(rank) + ' ('+rc+')' + ' of '+str(plrcnt))
	rankPopup.addline('      Skill ' + str(skill) + ' ('+skc+')' +' points')
	rankPopup.addline('      Total Games ' + str(plr_games))
	rankPopup.addline('      Total Rounds ' + str(plr_rounds))
	rankPopup.addline('  ')
	rankPopup.addline('->2 - Kill Profile')
	rankPopup.addline('      KDR: ' +kdr)
	rankPopup.addline('      Kills per minute: ' + str(kpm))
	rankPopup.addline('      Kill Streak: ' + str(plr_kills_str))
	rankPopup.addline('      Death Streak: ' + str(plr_deaths_str))
	rankPopup.addline('  ')
	rankPopup.addline('->3 - Team Profile')
	rankPopup.addline('      Prefered team: ' + pref_team)
	rankPopup.addline('      ' + str(pld_twon) + ' T Wins')
	rankPopup.addline('      ' + str(pld_tlost) + ' T Loses')
	rankPopup.addline('      ' + str(pld_ctwon) + ' CT Wins')
	rankPopup.addline('      ' + str(pld_ctlost) + ' CT Loses')
	rankPopup.addline('  ')
	rankPopup.addline('->4 - Action Profile')
	rankPopup.addline('    ' + str(pld_bomb_pl) + ' Bombs Planted')
	rankPopup.addline('    ' + str(pld_bomb_def_def) + ' Bombs Defused')
	rankPopup.addline('    ' + str(pld_reschost) + ' Hostages Rescued')
	rankPopup.addline('  ')

	rankPopup.send(userid)


#session, kpd
def showkpd(userid):
	global rankPopup
	uid				= cst.getUniqueId(userid)
	data 			= stats.getPlayerData(uid)
	rank			= data[1]
	rank_old		= data[2]
	skill 			= data[3]
	skill_old		= data[4]
	plrcnt			= data[5]
	plr_kills		= data[6]
	plr_deaths		= data[7]
	plr_hskills		= data[8]
 	plr_ffkills		= data[9]
	plr_ffdeaths	= data[10]
	plr_kills_str	= data[11]
	plr_deaths_str	= data[12]
	plr_suicides	= data[13]
	plr_games		= data[14]
	plr_rounds		= data[15]
	plr_online		= data[16]
	plr_ctkills		= data[17]
	plr_tkills		= data[18]
	plr_ctdeaths	= data[19]
	pld_tdeaths		= data[20]
	pld_bomb_def_att= data[21]
	pld_bomb_def_def= data[22]
	pld_bomb_exp	= data[23]
	pld_bomb_pl		= data[24]
	pld_bomd_sp		= data[25]
	pld_killhost	= data[26]
	pld_reschost	= data[27]
	pld_touchhost	= data[28]
	pld_ctwon		= data[29]
	pld_ctlost		= data[30]
	pld_twon		= data[31]
	pld_tlost		= data[32]
	plr_s_points	= data[33]
	plr_s_kills		= data[34]
	plr_s_deaths	= data[35]
	plr_s_hk		= data[36]
	plr_s_ffkills	= data[37]
	prl_s_ffdeaths	= data[38]
	plr_s_suicides	= data[39]

	try:
		hp = float (100 / float(plr_kills))
		hpc = int( float(hp) * float(plr_hskills))
	except:
		hpc = '0'

	rankchange = rank_old - rank
	if(rankchange > 0):
		rc = '+' + str(rankchange)
	elif(rankchange < 0):
		rc = str(rankchange)
	else:
		rc = ''

	if (plr_deaths == 0):
		kdr = "%.2f" % round(float(plr_kills)/float(1),2)
	else:
		kdr = "%.2f" % round(float(plr_kills)/float(plr_deaths),2)

	if (plr_s_points > 0):
		plr_s_points = '+' + str(plr_s_points)

	rankPopup = popuplib.create('rank_popup')
	rankPopup.addline('->1 - Total Ranking')
	rankPopup.addline('      Position ' + str(rank) + ' of '+str(plrcnt))
	rankPopup.addline('      ' + str(skill) + ' Points')
	rankPopup.addline('      ' + str(plr_kills) + ' : ' + str(plr_deaths) + ' Frags')
	rankPopup.addline('      ' + str(plr_hskills) + ' (' + str(hpc) + '%) Headshots')
	rankPopup.addline('      ' + kdr + ':' + ' KDR')
	rankPopup.addline('  ')
	rankPopup.addline('->2 - This Session')
	rankPopup.addline('      ' + str(plr_s_points) + ' Points')
	rankPopup.addline('      ' + str(plr_s_kills) + ' : ' + str(plr_s_deaths) + ' Frags')
	rankPopup.addline('      ' + str(rc) + ' Positions')
	rankPopup.addline('      ' + str(plr_s_hk) + ' Headshots')
	rankPopup.addline('  ')
	rankPopup.addline('->3 - Achievements')
	rankPopup.addline('    ' + str(plr_ffkills) + ' Teamkills')
	rankPopup.addline('    ' + str(plr_suicides) + ' Suicides')
	rankPopup.addline('    ' + str(pld_bomb_pl) + ' Bombs Planted')
	rankPopup.addline('    ' + str(pld_bomb_def_def) + ' Bombs Defused')
	rankPopup.addline('    ' + str(pld_reschost) + ' Hostages Rescued')
	rankPopup.addline('    ' + str(pld_killhost) + ' Hostages Killed')
	rankPopup.addline('  ')

	rankPopup.send(userid)

# ================================================================================== #
# =================== A d d o n   C l a s s e s   L i b r a r y ==================== #
# ================================================================================== #
class stats(object):

	def getPlayerData(self, uid):
		q = sql_c.cursor()
		cst.log(str(uid))
		query = ' SELECT pl.plrid, pl.rank, pl.prevrank, pl.skill, pl.prevskill, ( SELECT COUNT( plrid ) cnt FROM `ps_plr`) AS plr_cnt, pld.kills, pld.deaths, pld.hskills, pld.ffkills, pld.ffdeaths, pld.kills_streak, pld.deaths_streak, pld.suicides, pld.games, pld.rounds, pld.onlinetime, pld.ctkills , pld.terroristkills, pld.ctdeaths, pld.terroristdeaths, pld.bomd_def_att, pld.bomd_def, pld.bomb_exp, pld.bomb_pl, pld.bomd_sp, pld.killhost, pld.reschost, pld.touchhost, pld.ctwon, pld.ctlost, pld.twon,  pld.tlost, (ps.skill - ps.prevskill) s_points, ps.kills s_kills, ps.deaths s_deaths, ps.headshotkills s_hk, ps.ffkills s_ffkills, ps.ffdeaths s_ffdeaths, ps.suicides s_suicides '
		query = query + ' FROM `ps_plr` pl, `ps_plr_sessions` ps, ( SELECT pdt.plrid, SUM( pdt.kills ) kills, SUM( pdt.deaths ) deaths, SUM(pdt.headshotkills) hskills,SUM( pdt.ffkills ) ffkills, SUM( pdt.ffdeaths ) ffdeaths, MAX( pdt.kills_streak ) kills_streak, MAX( pdt.deaths_streak ) deaths_streak, SUM( pdt.suicides ) suicides, SUM( pdt.games ) games, SUM( pdt.rounds ) rounds, SUM( pdt.onlinetime ) onlinetime, SUM(pdts.ctkills) ctkills ,SUM(pdts.terroristkills) terroristkills,SUM(pdts.ctdeaths) ctdeaths,SUM(pdts.terroristdeaths) terroristdeaths,SUM(pdts.bombdefuseattempts) bomd_def_att,SUM(pdts.bombdefused) bomd_def,SUM(pdts.bombexploded) bomb_exp,SUM(pdts.bombplanted) bomb_pl,SUM(pdts.bombspawned) bomd_sp,SUM(pdts.killedhostages) killhost,SUM(pdts.rescuedhostages) reschost,SUM(pdts.touchedhostages) touchhost, '
		query = query + ' SUM(pdts.ctwon) ctwon,SUM(pdts.ctlost) ctlost,SUM(pdts.terroristwon) twon, SUM(pdts.terroristlost) tlost FROM `ps_plr_data` pdt, `ps_plr_data_halflife_cstrike` pdts WHERE pdts.dataid = pdt.dataid GROUP BY pdt.plrid)pld WHERE ps.plrid = pl.plrid AND pl.uniqueid = "'+str(uid)+'" AND ps.dataid = (SELECT MAX( dataid ) FROM ps_plr_sessions psm WHERE psm.plrid = pl.plrid ) AND pld.plrid = pl.plrid '

		q.execute(query)
		n = int(q.rowcount)
		if(n < 1):
			data = '-1'
		else:
			data = q.fetchone()
		return data

stats = stats()

class cst(object):
	def init(self):
		self.log('-- Psychostats 3.1 - Ranks & Statistics Modification for CS:Source Servers --')
		self.mysql_connect()
	def log(self, msg):
		es.dbgmsg(0, msg);

	def mysql_connect(self):
		global sql_c
		self.log('Attempting to connect to [' + str(ps_mysql_hostname)+ ']...')
		try:
			sql_c = MySQLdb.connect(ps_mysql_hostname, ps_mysql_username, ps_mysql_password, ps_mysql_database)
			if(sql_c):
				self.log('Successfully connected to '+str(ps_mysql_hostname)+' with username "'+str(ps_mysql_username)+'".')

		except MySQLdb.Error, e:
			self.log('ERROR: Could not connect to the MySQL Server!')
			self.log('ERROR: ' + str(e))
			es.unload(info.basename)
			return

	def preloadSettings(self):
		q = sql_c.cursor()
		q.execute('SELECT var, value FROM `ps_config`')
		q.execute('SELECT * FROM `ps_config_plrbonuses` WHERE modtype = "" OR modtype = "cstrike"')

	def getUniqueId(self, userid):
		global ps_stats_calc_mode
		if (ps_stats_calc_mode == 1):
			return str(es.getplayersteamid(userid))
		elif (ps_stats_calc_mode == 2):
			return str(es.getplayername(userid))
		else:
			return str(es.getplayername(userid))


cst = cst()
# ================================================================================== #
